function [nu na] = corner_nus(bc, l, nc, ang)
% function [nu na] = corner_nus(bc, l, nc, ang)
%
% Return list of nu values, and na giving how many basis coeffs at each corner
% Note that -ve nu's encode sin-type basis, +ve cos-type.

nu = [];
na = zeros(1, nc);       % number of expansion coeffs at each corner
maxl = max([circshift(l,[0 1]); l]); % works for tri only: max dist from corner
for n=1:nc
  if bc=='n'
    nua = 0:pi/ang(n):maxl(n);      % include zero nu
  elseif bc=='d'
    nua = pi/ang(n):pi/ang(n):maxl(n);      % don't include zero nu
    nua = -nua;                         % encode sin-type via -ve nu's
  elseif bc=='b'
    i = floor(maxl(n)/(pi/ang(n)));         % how many to go up to
    nua = (-i:i) * pi/ang(n);      % again, encode sin-type via -ve nu's
  end
  na(n) = numel(nua); nu = [nu nua];
end
