
% TEST ROUTINES:

if 0         % test view basis funcs
  k = 10;
  s = setup_corner_basis(bil, eta*k, 'b');
  g = 0:0.02:1; [v1 v2] = meshgrid(g,g);
  C = corner_basis(s.na, s.c1, s.c2, s.th, v1, v2, k, s.nu);
  figure;
  for j=1:s.N
    x = zeros(s.N,1); x(j) = 1;                      % basis coeff to plot
    u = reshape(C*x, size(v1));
    subplot(5,8,j);
    imagesc(g,g,u); set(gca, 'ydir', 'normal'); caxis([-.5 .5]); axis equal;
    hold on; plot(quad.x1, quad.x2, 'markersize', 1);
  end
end

if 0          % test the normal derivatives correct
    [B,C] = corner_basis(s.na, s.c1, s.c2, s.th, quad.x1, quad.x2, k, s.nu,...
                         quad.nx1, quad.nx2);
    d = 1e-4;
    Cd = (corner_basis(s.na, s.c1, s.c2, s.th, quad.x1+d*quad.nx1, ...
                       quad.x2+d*quad.nx2, k, s.nu)-...
          corner_basis(s.na, s.c1, s.c2, s.th, quad.x1, quad.x2, k, s.nu))/d;
    figure;imagesc(C); colorbar; title('C');
    figure;imagesc(Cd-C); colorbar; title('Cd-C');  % should be small
end

if 0         % test view basis values or normal derivs
  [B,A] = corner_basis(s.na, s.c1, s.c2, s.th, quad.x1, quad.x2, k, s.nu, ...
                       quad.nx1, quad.nx2);
  if (bcs.type=='n')
    B = A;
  end
  figure; imagesc(B); colorbar; xlabel('j, basis func'); ylabel('i, bdry pt');
end

if 0
Es= 10:1:100;
ks = sqrt(Es);
nk = numel(ks);
s = ones(N, nk)*NaN;            % fill plotting sigma array with dummy values
% -------------------- regular sweep plot ----------------------------
for j=1:nk
  k = ks(j);
  if (bc=='d')   % fill the A matrix with basis on bdry
    [A] = corner_basis(na, c1, c2, th, x1, x2, k, nu);
    A = diag(sqrt(w))*A;
    B = corner_basis(na, c1, c2, th, y1, y2, k, nu); % interior values
    B = diag(sqrt(wi))*B;   % interior norm
  elseif bc=='n'
    [B,A] = corner_basis(na, c1, c2, th, x1, x2, k, nu, nx1, nx2);
    A = diag(sqrt(w))*A;
    if nor=='i'
      B = corner_basis(na, c1, c2, th, y1, y2, k, nu); % interior values
      B = diag(sqrt(wi))*B;   % interior norm
    else
      B = diag(sqrt(w))*B;    % bdry norm use to approx interior norm
    end
  end
  A = diag(sqrt(w))*A;
  %imagesc(A); title(sprintf('k=%g',k)); drawnow;
  if meth=='s'                  % SVD
    s(:,j) = svd(A);
  elseif meth=='g'              % Betcke
    s(:,j) = gsvd(A,B);
  elseif meth=='v'              % reg GEVP
    [V,D] = eig(B'*B); mD=max(diag(D)); i=find(diag(D)>1e-14*mD);
    V=V(:,i); L=inv(sqrt(D(i,i)));
    disp(sprintf('k=%g, B numerical rank=%d', k, numel(i)));
    s(1:numel(i),j) = sqrt(eig(L*V'*A'*A*V*L)); % projects out num. Nul(B)
  end
end
figure; %semilogy(ks, s, '.'); xlabel('k'); ylabel('\sigma_j(k)');title(meth);
plot(ks, s, '.'); xlabel('k'); ylabel('\sigma_j(k)');title(meth);
end
if 0
Es = ks.^2;
figure; plot(Es, s, '.'); xlabel('E'); ylabel('\sigma_j(k)');
axis([min(Es) max(Es) 0 1]); title(sprintf('bc=%s', bc));
end
% why can't get minimum at 39.900 to get below 5e-3 in singular value, even
% when numerical rank maxed out at N=57?
% Because didn't use *both* sin adn cos type basis funcs - needed!

if 0
% fricka timing: about 11 us per bessel, in this range...
tic;besselj(rand(1000)*10, rand(1000)*10);toc
end



nk = numel(ks);
s = ones(N, nk)*NaN;            % fill plotting sigma array with dummy values
% ----------------------- scaling-type sweep plot ----------------------------
for j=1:nk
  k = ks(j);
  if (bc=='d')   % attempt scaling with deriv of A^T.A, and A^T.A
    dk = 1e-6;
    A = diag(sqrt(w))*corner_basis(na, c1, c2, th, x1, x2, k, nu);
    F = A'*A;
    Ad = diag(sqrt(w))*corner_basis(na, c1, c2, th, x1, x2, k+dk, nu);
    G = Ad'*Ad;
    G = (G-F)/dk;        % k-deriv of A'*A
  elseif bc=='n' % attempt scaling for neumann
    dk = 1e-6;
    [B,A] = corner_basis(na, c1, c2, th, x1, x2, k, nu, nx1, nx2);
    A = diag(sqrt(w))*A;              % A is the basis bdry derivs
    F = A'*A;
    [B,Ad] = corner_basis(na, c1, c2, th, x1, x2, k+dk, nu, nx1, nx2);
    Ad = diag(sqrt(w))*Ad;
    G = Ad'*Ad;
    G = (G-F)/dk;        % k-deriv of A'*A
  elseif bc=='c'      % dirichlet, regular normalization but deriv of A'*A.
    dk = 1e-6;
    A = diag(sqrt(w))*corner_basis(na, c1, c2, th, x1, x2, k, nu);
    F = A'*A;
    Ad = diag(sqrt(w))*corner_basis(na, c1, c2, th, x1, x2, k+dk, nu);
    G = Ad'*Ad;
    G = (G-F)/dk;        % k-deriv of A'*A
    if nor=='i'
      B = corner_basis(na, c1, c2, th, y1, y2, k, nu); % interior values
      B = diag(sqrt(wi))*B;     % interior norm
    else                        % bdry norm using normal derivs
      [A,B] = corner_basis(na, c1, c2, th, x1, x2, k, nu, nx1, nx2);
      B = diag(sqrt(w))*B;
    end
    F = B'*B;
  elseif bc=='m'      % dirichlet, regular normalization but deriv of A'*A.
    dk = 1e-6;
    [B,A] = corner_basis(na, c1, c2, th, x1, x2, k, nu, nx1, nx2);
    A = diag(sqrt(w))*A;              % A is the basis bdry derivs
    F = A'*A;
    [B,Ad] = corner_basis(na, c1, c2, th, x1, x2, k+dk, nu, nx1, nx2);
    Ad = diag(sqrt(w))*Ad;
    G = Ad'*Ad;
    G = (G-F)/dk;        % k-deriv of A'*A
    if nor=='i'
      B = corner_basis(na, c1, c2, th, y1, y2, k, nu); % interior values
      B = diag(sqrt(wi))*B;     % interior norm
    else                        % bdry norm using values
      B = diag(sqrt(w))*corner_basis(na, c1, c2, th, x1, x2, k, nu, nx1, nx2);
    end
    F = B'*B;
  end
  if meth=='f'                  % 
    s(:,j) = eig(F);
  elseif meth=='g'              %
    s(:,j) = eig(G);
  elseif meth=='v'              % reg GEVP
    [V,D] = eig(F); mD=max(diag(D)); i=find(diag(D)>1e-14*mD);
    V=V(:,i); L=inv(sqrt(D(i,i)));
    disp(sprintf('k=%g, F numerical rank=%d', k, numel(i)));
    s(1:numel(i),j) = eig(L*V'*G*V*L);
  end
end
figure; plot(ks, s, '.'); xlabel('k'); ylabel('\sigma_j(k)')
title([meth ' bas=' bas ' bc=' bc ' nor=' nor]); axis tight;
axis([min(ks) max(ks) -1 1]);



if 0  % ------------------------------------------  generate eigenvector plots
  k = 7.14;
  dk = 1e-6;
  [B,A] = corner_basis(na, c1, c2, th, x1, x2, k, nu, nx1, nx2);
  A = diag(sqrt(w))*A;              % A is the basis bdry derivs
  F = A'*A;
  [B,Ad] = corner_basis(na, c1, c2, th, x1, x2, k+dk, nu, nx1, nx2);
  Ad = diag(sqrt(w))*Ad;
  G = Ad'*Ad;
  G = (G-F)/dk;        % k-deriv of A'*A
  [V,D] = eig(F); mD=max(diag(D)); i=find(diag(D)>1e-14*mD);
  V=V(:,i); L=inv(sqrt(D(i,i)));
  disp(sprintf('k=%g, F numerical rank=%d', k, numel(i)));
  s = 1./ eig(L*V'*G*V*L);
  g = 0:0.02:1; [v1 v2] = meshgrid(g,g);
  C = corner_basis(na, c1, c2, th, v1, v2, k, nu);
  figure;
  for j=1:N
    u = reshape(C*V(:,j), size(v1));
    subplot(3,4,j);
    imagesc(g,g,u); set(gca, 'ydir', 'normal'); %caxis([-.5 .5]);
    axis equal; hold on; plot(x1, x2, 'markersize', 1);
    title(sprintf('s_%d=%g',j,s(j)));
  end
end

% search --------------------------------------------------------------------

% single search window
a = 10; b = 100;
opts=[]; opts.ttyp=1e-4; opts.recur=3; cmin=0.7e-2; cmax=1.5e-2;
opts.maxparit=5; opts.select=1; opts.v=2; opts.maxdegen=100; opts.xtol=1e-2;
[E,t,info] = fparamin(a, b, cmin, cmax, opts, @param_spec, bc, nor, meth, na, c1, c2, th, x1, x2, nu, nx1, nx2, w, wi);
info.fevals

%end
